
                    include hardware.i
                    include macros.i

;------------------------------------------------------------------------------
                    section code, code

                    public _SetSystem, _AutoTilemap

                    ; wrapper for SetSystem

_SetSystem          push      d2-d7/a2-a6
                    moveq     #2, d0
                    moveq     #0, d1
                    moveq     #0, d2
                    moveq     #-1, d3
                    jsr       SetSystem
                    pop       d2-d7/a2-a6
                    rts

_AutoTilemap        ; align all buffers on 64K boundary

                    move.l    #BSS+65536, d0
                    clr.w     d0
                    move.l    d0, Tiles
                    add.l     #Tilesize, d0
                    move.l    d0, Tilemap
                    add.l     #20*16, d0
                    move.l    d0, Screen

                    ; move the tile graphics in place

                    move.l    Tiles, a1
                    add       #Tilesize, a1
                    lea       Tiledata+Tilesize, a0
                    move.w    #Tilesize-1, d0
.1                  move.b    -(a0), -(a1)
                    dbf       d0, .1

                    ; write all required pointers into the copper program

                    move.l    Screen, d0
                    lea       Bitplaneptrs, a0
                    moveq     #3-1, d1
.2                  move.w    d0, (a0)
                    swap      d0
                    move.w    d0, (4, a0)
                    swap      d0
                    add.l     #320/8, d0
                    add       #8, a0
                    dbf       d1, .2

                    move.w    Tiles, Tilepages
                    move.w    Screen, Tilepages+4

                    move.l    Screen, a0
                    lea       Tileblits, a1
                    moveq     #16-1, d0
.3                  moveq     #20-1, d1
.4                  move.w    a0, (4, a1)
                    add       #16, a1
                    add       #2, a0
                    dbf       d1, .4
                    add       #40*16*3-40, a0
                    dbf       d0, .3

                    move.l    Tilemap, d0
                    move.w    d0, Mapsrc1
                    swap      d0
                    move.w    d0, Mapsrc1+4
                    move.l    #Tileblits, d0
                    move.w    d0, Mapdst1
                    swap      d0
                    move.w    d0, Mapdst1+4

                    move.l    Tilemap, d0
                    add.l     #20*16-2, d0
                    move.w    d0, Mapsrc2
                    swap      d0
                    move.w    d0, Mapsrc2+4
                    move.l    #Tileblits+20*16*16-16, d0
                    move.w    d0, Mapdst2
                    swap      d0
                    move.w    d0, Mapdst2+4

                    ; display settings

                    move.w    #bpl_3bpl|bpl_color, bplcon0
                    move.w    #0, bplcon1
                    move.w    #0, bplcon2

                    move.w    #40*3-40, bpl1mod
                    move.w    #40*3-40, bpl2mod
                    move.w    #$38, ddfstrt
                    move.w    #$d0, ddfstop
                    move.w    #$2c81, diwstrt
                    move.w    #$2cc1, diwstop

                    move.w    #$000, color0
                    move.w    #$888, color1
                    move.w    #$f00, color2
                    move.w    #$800, color3
                    move.w    #$0f0, color4
                    move.w    #$080, color5
                    move.w    #$44f, color6
                    move.w    #$228, color7

                    move.w    #cop_cdang, copcon
                    move.l    #Copperprog, cop1lc
                    tst.w     copjmp1
                    waitframe
                    move.w    #dma_set|dma_en|dma_bpl|dma_cop|dma_blt, dmacon

                    ; the tilemap is now up and running. the copper drives the
                    ; blitter to do all necessary copying and drawing, and the 
                    ; user only has to poke the tilemap.

                    move.l    Tilemap, d0
                    rts


Tiledata            incbin tiles.raw
Tilesize = *-Tiledata

Screen              ds.l 1
Tiles               ds.l 1
Tilemap             ds.l 1



;------------------------------------------------------------------------------
                    section data_c, data_c

Copperprog
Bitplaneptrs = *+2  cmove     0, bpl1ptl, 0, bpl1pth
                    cmove     0, bpl2ptl, 0, bpl2pth
                    cmove     0, bpl3ptl, 0, bpl3pth
                    cmove     dma_set|dma_bltpri, dmacon

                    ; prepare even columns of tiles for blitting

                    cwaitblt
                    cmove     $7000|blt_ad|$f0, bltcon0, 0, bltcon1
                    cmove     $ff00, bltafwm, $ff00, bltafwm
                    cmove     0, bltamod, 14+16, bltdmod
Mapsrc1 = *+2       cmove     0, bltaptl, 0, bltapth
Mapdst1 = *+2       cmove     0, bltdptl, 0, bltdpth
                    cmove     ((10*16)<<6)|1, bltsize

                    ; prepare odd columns

                    cwaitblt
                    cmove     $1000|blt_ad|$f0, bltcon0, blt_desc, bltcon1
                    cmove     $00ff, bltafwm, $00ff, bltafwm
                    cmove     0, bltamod, 14+16, bltdmod
Mapsrc2 = *+2       cmove     0, bltaptl, 0, bltapth
Mapdst2 = *+2       cmove     0, bltdptl, 0, bltdpth
                    cmove     ((10*16)<<6)|1, bltsize

                    ; blit all 20*16 tiles to the screen

                    cwaitblt
                    cmove     blt_ad|$f0, bltcon0, 0, bltcon1
                    cmove     $ffff, bltafwm, $ffff, bltalwm
                    cmove     8, bltamod, 38, bltdmod
Tilepages = *+2     cmove     0, bltapth, 0, bltdpth

Tileblits = *+2
                    rept 20*16
                     cmove    0, bltaptl, 0, bltdptl
                     cmove    ((16*3)<<6)|1, bltsize
                     cwaitblt
                    endr

                    cmove     dma_clr|dma_bltpri, dmacon
                    cend



;------------------------------------------------------------------------------
                    section bss_c, bss_c                    

                    ; tile graphics, tile map, screen space, and padding
                    ; for a quick way to align on 64K boundary

BSS                 ds.b 65536 + 20*16 + 320*256*3/8
